<?php

namespace Chippyash\Test\Validation\Common;

use Chippyash\Validation\Messenger;

/**
 * Generated by PHPUnit_SkeletonGenerator 1.2.1 on 2013-11-05 at 16:19:08.
 */
class EmailTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @var \Chippyash\Validation\Common\Email
     */
    protected $sut;

    protected function setUp()
    {
        $this->sut = new \Chippyash\Validation\Common\Email();
    }

    /**
     * @dataProvider emails
     */
    public function testWillReturnCorrectResponseForTestDataSetViaMagicInvokeMethod($email, $result, $message)
    {
        $sut = $this->sut;;
        $messenger = new Messenger();
        $this->assertEquals($result, $sut($email, $messenger));
        if (!$result) {
            $this->assertEquals($message, $messenger->implode());
        }
    }

    /**
     * @dataProvider emails
     */
    public function testWillReturnCorrectResponseForTestDataSetViaIsValidMethod($email, $result, $message)
    {
        $this->assertEquals($result, $this->sut->isValid($email));
        if (!$result) {
            $this->assertEquals($message, implode(' : ', $this->sut->getMessages()));
        }
    }

    public function emails()
    {
        return array(
            array('a@b.com', true, null),
            array('a@b', false, "'b' is not a valid hostname for the email address : The input does not match the expected structure for a DNS hostname : The input appears to be a local network name but local network names are not allowed"),
            array('@b.co.uk', false, 'The input is not a valid email address. Use the basic format local-part@hostname'),
            array(null, false, 'Invalid type given. String expected'),
        );
    }
}
