<?php

namespace Chippyash\Test\Validation\Pattern;

use Chippyash\Validation\Messenger;
use Chippyash\Validation\Common\IsTraversable;

/**
 * Generated by PHPUnit_SkeletonGenerator 1.2.1 on 2013-09-25 at 19:52:17.
 */
class IsTraversableTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var messenger
     */
    protected $messenger;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
        $this->messenger = new Messenger();
    }


    public function testYouCanValidateWithAnArray() {
        $v = new IsTraversable;
        $this->assertTrue($v(array('a','b','c'), $this->messenger));
    }

    public function testYouCanValidateWithATraversable()
    {
        $v = new IsTraversable;
        $obj = $this->getMock('\Iterator', array(
            'current', 'key', 'next', 'rewind' , 'valid'
        ));
        $this->assertTrue($v($obj, $this->messenger));
    }

    public function testYouCanValidateWithAStdClass()
    {
        $v = new IsTraversable;
        $obj = new \stdClass();
        $this->assertTrue($v($obj, $this->messenger));
    }

    public function testValidatingWithANonTraversableWillReturnFalse()
    {
        $v = new IsTraversable;
        $obj = 'foo';
        $this->assertFalse($v($obj, $this->messenger));
        $this->assertEquals('value is not traversable', (string) $this->messenger);
    }
}
